//////////////////////////////////////////////////////////////////////
// Copyright (c) 1999 by Krzysztof Kuczek
// All rights reserved
//
// Distribute freely, but don't remove my name from source and documentation.
//
// No warrantee of any kind, express or implied, is included with this
// software; use at your own risk, responsibility for damages (if any) to
// anyone resulting from the use of this software rests entirely with the
// user.
// 
// Send bug reports, bug fixes, etc.
//
// email: qczek@student.uci.agh.edu.pl
// http://student.uci.agh.edu.pl/~qczek
//


#if !defined(AFX_PERFSTATS_H__5DA542B0_C413_11D2_A929_004005326AD5__INCLUDED_)
#define AFX_PERFSTATS_H__5DA542B0_C413_11D2_A929_004005326AD5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

typedef struct 
{
	char KeyName[MAX_PATH];
	char Name[MAX_PATH];
} CATEGORY_STRUCT;


typedef struct 
{
	char KeyName[MAX_PATH];
	char Name[MAX_PATH];
	char Description[MAX_PATH];
	BOOL Differentiate;

}ELEMENT_STRUCT;


class CPerfStats  
{



public:
	CPerfStats();
	
	BOOL EnumCategories( void );
	BOOL EnumElements( CATEGORY_STRUCT * pCategory );
	DWORD GetValue( ELEMENT_STRUCT * pElement);	
	virtual void OnHitCategory( CATEGORY_STRUCT * pCategory ) = 0;
	virtual void OnHitElement( ELEMENT_STRUCT * pElement ) = 0;


	virtual ~CPerfStats();

private:

	CATEGORY_STRUCT CategoryTab[256];
	ELEMENT_STRUCT ElementTab[256];

};

#endif // !defined(AFX_PERFSTATS_H__5DA542B0_C413_11D2_A929_004005326AD5__INCLUDED_)
